#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cokus.h"

extern void clkbegin(), clkend();
extern int CLKcount;
extern float CLKclock;

#define N 1024		/* N*4bytes */
#define COUNT 10000	/* test */

extern void test1A(int *src, int n );
extern void test2A(int *src, int n );

void test1C( int *src, int n ){
	while( n ){
		if( *src < 0 ) *src = -*src;
		src++;
		n--;
	}
}

int test2C( int *src, int n ){
	int max = 0;
	while( n ){
		if( *src > max ) max = *src;
		src++;
		n--;
	}
	return max;
}

void setup( int *data , int type ){
	int i, minus = 0;
	switch( type ){
	default:
	case '0':
		for( i = 0; i < N; i++ ){
			data[i] = i;
		}
		break;
	case '1':
		for( i = 0; i < N; i++ ){
			data[i] = -i;
		}
		break;
	case '2':
		for( i = 0; i < N; i++ ){
			data[i] = randomMT() - randomMT();
//			if( data[i] < 0 ) printf("-"); else printf("+");
		}
		break;
	case '3':
		for( i = 0; i < N; i++ ){
			data[i] = randomMT() * 0.2 - randomMT() * 0.8;
		}
		break;
	case '4':
		for( i = 0; i < N; i++ ){
			data[i] = randomMT() * 0.8 - randomMT() * 0.2;
		}
		break;
	}
	for( i = 0; i < N; i++ ){
		if( data[i] < 0 ) minus++;
	}
	printf("rate = %d/%d(%f)\n", minus, N, minus/(float)N );
}

int main(int argc, char *argv[]){
	int i, debug = 0, type;
	char __data[N * 4 + 32];
	int buf[N];
	int *data = (int *)( ((int)(__data) + 31 ) & -32 );
	argc--,argv++;
	type = '0';
	seedMT( 1 );
	if( argc ) type = **argv;

	setup( data, type );
	memcpy( buf, data, N * 4 );		/* testdata¸ */

	CLKcount = CLKclock = 0;
	for( i = 0; i < COUNT; i++ ){
		clkbegin();
		test1A( data, N );
		clkend();
		memcpy( data, buf, N * 4 );	/* testdata */
	}
	printf("test1A : %f(%d)\n", CLKclock/(float)CLKcount, CLKcount);

	CLKcount = CLKclock = 0;
	for( i = 0; i < COUNT; i++ ){
		clkbegin();
		test2A( data, N );
		clkend();
		memcpy( data, buf, N * 4 );	/* testdata */
	}
	printf("test2A : %f(%d)\n", CLKclock/(float)CLKcount, CLKcount);

#if 0
	if( !debug ) return 0;
	puts( "- debug -" );

	for( i = 0; i < N; i++ ){
		if( data[i] != buf2[i] )
		{
			printf("%4d:org=%8X 1:%8X 2:%8X\n",i, buf[i], buf2[i], data[i] );
		}
	}
#endif
	return 0;
}
